/*
 *   SIMPLL - A tool for PLL syntesizer loop filter optimization 
 *
 *      (c) by Lapo Pieri IK5NAX  2006
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send bugs reports, comments, critique, etc, to (ik5nax #AT# amsat.org) or
 *  (lapo_pieri #AT# virgilio.it)
 */

#include <stdio.h>
#include <math.h>
#include "dataconv.h"

void double2prefs(double v, int df, char *b, int isspice) {
  double p;
  char pds[32];  

  if(v!=0.){
    p=log10(fabs(v));
    if(p>=-18. && p<-15.) sprintf(b, "%6.2fa", v*1e18);
    else if(p>=-15. && p<-12.){
      sprintf(pds, "%%%d.%dff", df+4, df);
      sprintf(b, pds, v*1e15);
    }
    else if(p>=-12. && p<-9.){
      sprintf(pds, "%%%d.%dfp", df+4, df);
      sprintf(b, pds, v*1e12);
    }
    else if(p>=-9. && p<-6.){
      sprintf(pds, "%%%d.%dfn", df+4, df);
      sprintf(b, pds, v*1e9);
    }
    else if(p>=-6. && p<-3.){
      sprintf(pds, "%%%d.%dfu", df+4, df);
      sprintf(b, pds, v*1e6);
    }
    else if(p>=-3. && p<0.){
      sprintf(pds, "%%%d.%dfm", df+4, df);
      sprintf(b, pds, v*1e3);
    }
    else if(p>=0. && p<3.){
      sprintf(pds, "%%%d.%df ", df+4, df);
      sprintf(b, pds, v);
    }
    else if(p>=3. && p<6.){
      sprintf(pds, "%%%d.%dfk", df+4, df);
      sprintf(b, pds, v*1e-3);
    }
    else if(p>=6. && p<9.) {
      if(isspice) sprintf(pds, "%%%d.%dfMEG", df+4, df);
      else sprintf(pds, "%%%d.%dfM", df+4, df);
	sprintf(b, pds, v*1e-6);
    }
    else if(p>=9. && p<12.){
      sprintf(pds, "%%%d.%dfG", df+4, df);
      sprintf(b, pds, v*1e-9);
    }
    else if(p>=12. && p<15.){
      sprintf(pds, "%%%d.%dfT", df+4, df);
      sprintf(b, pds, v*1e-12);
    }

    else{
      sprintf(pds, "%%%d.%dg", df+4, df);
      sprintf(b, pds, v);
    }

  }
  else sprintf(b, "0");
}
